#include <iostream>
#include "ngf/Ngf.h"
#include "fbcrate/FBcrate.h"

static const unsigned int  NGF_BASEADDR = 0x80e00000;
Ngf  ngf( NGF_BASEADDR );

void
frc( unsigned int pa,unsigned int sa,unsigned int* data )
{
  ngf.frc( pa,sa,data );
}

void
fwc( unsigned int pa,unsigned int sa,unsigned int data )
{
  ngf.fwc( pa,sa,data );
}

void
frd( unsigned int pa,unsigned int sa,unsigned int* data )
{
  ngf.frd( pa,sa,data );
}

void
fwd( unsigned int pa,unsigned int sa,unsigned int data )
{
  ngf.fwd( pa,sa,data );
}

void
reset()
{
  ngf.SeqResetReg( 0 );
  ngf.SeqEnableReg( 0 );
}




int
main( int argc,char* argv[] )
{
  if ( argc < 2 ){
    std::cout << "usage : fbmod config_file" << std::endl;
    return( 0 );
  }

  // init NGF
  ngf.SeqResetReg( 0 );
  ngf.FbTimeoutReg( 0x73 );
  ngf.disableInterrupt();
  ngf.maskInterrupt( NGF_CLEAR_INT_ALL ); // disable all
  ngf.SeqEnableReg( 0 );

  // init FB
  FBcrate  fb;

  fb.readConf( argv[1] );
  fb.dumpConf();
  fb.setFunc( frc,fwc,frd,fwd,reset );

  fb.init();

  return( 0 );
}
