// -*- C++ -*-
//
// gsim.cc
// gsim main program
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Fri Apr 20 15:44:51 JST 2001
//
// $Id: gsim_barrelveto.cc,v 1.1.1.1 2002/08/13 12:48:09 kensh Exp $
//
// Revision History
//
// $Log: gsim_barrelveto.cc,v $
// Revision 1.1.1.1  2002/08/13 12:48:09  kensh
//
//
// Start version.
//
//

#include "ccfortran/ccfortran.h"
#include "gsim-general/GsimGeneral.h"


////////////////
const static int NGBANK = 30000000;
const static int NHBOOK = 20000000;


////////////////
extern "C" {
  float  gcbank_[NGBANK];
  int    pawc_[NHBOOK];
  void  uginit_();
  void  uglast_();
}


////////////////
int
main( int argc, const char* argv[] )
{
  if ( argc <= 1 ){
    GsimUsage();
    return( -1 );
  }
  
  // parce command parameters
  GsimParams( argc, argv );

  // GEANT Initialization
  GZEBRA(  NGBANK );
  HLIMIT( -NHBOOK );
  Uginit();
  
  // Event Loop
  GsimEventLoop();
  
  // GEANT termination
  Uglast();
  
  //
  return( 0 );
}


