// -*- C++ -*-
//
// TdcModule.h
//
//
//

#ifndef TDCMODULE_H_INCLDUED
#define TDCMODULE_H_INCLDUED

#include <iostream>
#include <list>

#define  MAX_TDC_CH  64

//
class TdcModule {
public:
  // constructor
  TdcModule( int crate=-1, int ma=-1 );
  ~TdcModule();
  // extractor
  inline int   crate() const { return m_crate; }
  inline int   ma()    const { return m_ma;    }
  inline int   data( int ch ) const ;
  inline const std::list<unsigned int>&  hitList() const { return m_hitList; }
  inline       std::list<unsigned int>&  hitList()       { return m_hitList; }
  inline int   nhit()  const ;
  inline unsigned long long  hitPattern() const;
  void         show() const;
  // modifier
  inline void  setCrate( int crate ){ m_crate = crate; }
  inline void  setMa( int ma ) { m_ma = ma; }
  inline int   setData( int ch,int time );
  // friend
  friend std::ostream&  operator<<( std::ostream& out, const TdcModule& m );

private:
  // data
  int     m_crate;
  int     m_ma;
  int     m_ch[MAX_TDC_CH];
  std::list<unsigned int>  m_hitList;

};


// inline
//
inline int
TdcModule::nhit() const
{
  int  ct = 0;
  for( int i=0;i<MAX_TDC_CH;i++ ){
    if ( m_ch[i] >= 0 )
      ct++;
  }
  return( ct );
}

//
inline unsigned long long
TdcModule::hitPattern() const
{
  unsigned long long  pat = 0;
  for( int i=MAX_TDC_CH-1;i>=0;i-- ){
    pat <<= 1;
    if ( m_ch[i] >= 0 )
      pat |= 1;
  }
  return( pat );
}

//
inline int
TdcModule::data( int ch ) const
{
  if ( 0 <= ch && ch <MAX_TDC_CH )
    return( m_ch[ch] );
  return( -1 );
}


//
inline int
TdcModule::setData( int ch, int time )
{
  if ( 0 <= ch && ch <MAX_TDC_CH )
    return( m_ch[ch] = time );
  return( -1 );
}


#endif // TDCMODULE_H_INCLDUED
